/*
 * VARiD: A Variation Detection Framework for Colorspace and Letterspace platforms
 * Contact: <varid at cs dot toronto dot edu>
 * Copyright 2010 the authors (see README).
 *
 * This file is part of VARiD.
 *
 * VARiD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * VARiD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with VARiD.  If not, see <http://www.gnu.org/licenses/>.
 */
/*******************************************************************************
*                          Description
*                          -----------
* Include inlined timing help functions
*
*******************************************************************************/
#include <time.h>
#include <sys/time.h>
#include "../config.h"
#include "va_time.h"

long va_GetTime(struct timespec *tp) {
#ifdef HAVE_CLOCK_GETTIME
	return clock_gettime(CLOCK_REALTIME,tp);
#else
	struct timeval tv;
	int res = gettimeofday(&tv, NULL);
	if (res!=0) {
		return res;
	}
	tp->tv_sec = tv.tv_sec;
	tp->tv_nsec = tv.tv_usec*1000;
#endif
	return 0;
}
/*
struct timespec va_TimeAdd(
    const struct timespec * augPtr,
    const struct timespec * addPtr)
{
    struct timespec sum = *augPtr;

    sum.tv_sec  += addPtr->tv_sec;
    sum.tv_nsec += addPtr->tv_nsec;

    if (sum.tv_nsec >= NS_IN_SEC)
    {
        sum.tv_sec++;
        sum.tv_nsec -= NS_IN_SEC;
    }

    return sum;
}

struct timespec va_TimeSub(
    const struct timespec * minPtr,
    const struct timespec * subPtr)
{
    struct timespec dif = *minPtr;

    if (dif.tv_nsec < subPtr->tv_nsec)
    {
        dif.tv_sec--;
        dif.tv_nsec += NS_IN_SEC;
    }

    dif.tv_sec  -= subPtr->tv_sec;
    dif.tv_nsec -= subPtr->tv_nsec;

    return dif;
}

int va_TimeEq(
    const struct timespec * t1Ptr,
    const struct timespec * t2Ptr)
{
    int rc = 0;

    if ((t1Ptr->tv_sec == t2Ptr->tv_sec) 
        && (t1Ptr->tv_nsec == t2Ptr->tv_nsec))
    {
        rc = 1;
    }
    return (rc);
}

int va_TimeGt(
    const struct timespec * t1Ptr,
    const struct timespec * t2Ptr)
{
    int rc = 0;

    if (t1Ptr->tv_sec > t2Ptr->tv_sec)
        rc = 1;
    else if (t1Ptr->tv_sec == t2Ptr->tv_sec)
        rc = (t1Ptr->tv_nsec > t2Ptr->tv_nsec) ? 1 : 0;

    return (rc);
}

int va_TimeLt(
    const struct timespec * t1Ptr,
    const struct timespec * t2Ptr)
{
    int rc = 0;

    if (t1Ptr->tv_sec < t2Ptr->tv_sec)
        rc = 1;
    else if (t1Ptr->tv_sec == t2Ptr->tv_sec)
        rc = (t1Ptr->tv_nsec < t2Ptr->tv_nsec) ? 1 : 0;

    return (rc);
}
*/
