#include <stdio.h>
#include <stdlib.h>
#include <float.h>
#include "varid.h"


void print_matrix_double(FILE * f, VA_DOUBLE * data, int size_x, int size_y, VA_UINT8 * ref, VA_UINT8 * states) {
	int get_top=100;
	int x; int y;
	for (x=0; x<size_x; x++) {
		//for every position initialize the tops
		int top_states[get_top]; double top_values[get_top];
		int i;
		for (i=0; i<get_top; i++) {
			top_states[i]=-1;
			top_values[i]=-FLT_MAX;
		}
		//now iterate over all the states
		//as many times as needed
		for (i=0; i<get_top; i++) {
			for (y=0; y<size_y; y++) {
				int j; int skip=0;
				for (j=0; j<i && skip==0; j++) {
					if (top_states[j]==y) {
						skip=1;
					}
				}
				if (skip==0 && data[x*size_y+y]>top_values[i]) {
					top_values[i]=data[x*size_y+y];
					top_states[i]=y;
				}
			}
		}
		if (ref!=NULL) {
			fprintf(f,"%5c",ref[x]);
		}
		fprintf(f,"%10d%5c",x,' ');
		for (i=0; i<get_top; i++) {
			if (top_values[i]!=-FLT_MAX) {
				char s_state[50]; int z=top_states[i]*4;
				VA_VecU8 temp; temp.data=states+z; temp.size=4; temp=nuc2nuc(temp);
				sprintf(s_state,"%c%c/%c%c",temp.data[0],temp.data[1],temp.data[2],temp.data[3]);
				s_state[5]='\0';
				fprintf(f,"%10s %4d, ",s_state,top_states[i]);
				free(temp.data);
			}
		}
		fprintf(f,"\n");
		if (ref!=NULL) {
			fprintf(f,"%5c",' ');
		}
		fprintf(f,"%10c%5c",' ',' ');
		for (i=0; i<get_top; i++) {
			if (top_values[i]!=-FLT_MAX) {
				fprintf(f,"%4c%11.3e, ",' ',(top_values[i]));
			}
		}
		fprintf(f,"\n");
	}
	return; 
}
void print_matrix_double_raw(FILE * f, VA_DOUBLE * data, int size_x, int size_y) {
	int x; int y;
	for (x=0; x<size_x; x++) {
		fprintf(f,"%11d\t",x);
	}
	fprintf(f,"\n");
	for (y=0; y<size_y; y++) {
		for (x=0; x<size_x; x++) {
			fprintf(f,"%11.3f\t",data[x*size_y+y]);
		}
		fprintf(f,"\n");
	}
	return;
}
void print_matrix_int_raw(FILE * f, VA_INT32 * data, int size_x, int size_y) {
	int x; int y;
	for (x=0; x<size_x; x++) {
		fprintf(f,"%d\t",x);
	}
	fprintf(f,"\n");
	for (y=0; y<size_y; y++) {
		for (x=0; x<size_x; x++) {
			fprintf(f,"%d\t",data[x*size_y+y]);
		}
		fprintf(f,"\n");
	}
	return;
}

void print_genome(FILE * f, VA_VecU8 ref) {
	VA_VecU8 ls_ref = nuc2nuc(ref);
	int x;
	fprintf(f,"%10c\t", ' ');
	for (x=0; x<ref.size; x++) {
		fprintf(f,"%10d\t",x);
	}
	fprintf(f,"\n%10c\t",' ');
	for (x=0; x<ref.size; x++) {
		fprintf(f,"%10c\t",ls_ref.data[x]);
	}
	fprintf(f,"\n");
	return;
}
